/**
 * 
 */
package rest



/**
 * @author kfbishop
 * @returns array of acceptable content types, ordered by preference
 * Breaks out accept headers into useable list of media types.
 */
def getRequestHeaderMap() {
	return [
	        "Accept"         : getRequestHeaderValues("Accept"),
	        "Accept-Encoding": getRequestHeaderValues("Accept-Encoding"),
	        "Accept-Language": getRequestHeaderValues("Accept-Language"),
	        "Accept-CharSet" : getRequestHeaderValues("Accept-Charset"),
	        "Authorization"  : getRequestHeaderValues("Authorization"),
	]
}

def getRequestHeaderValues( headerName ) {
	def rawHeader = zget("/request/headers/in/${headerName}") 
	logger.INFO {"Raw Header value for ${headerName}: ${rawHeader}" }
	def headers = []
	if ( rawHeader ) {
		for ( value in rawHeader.split(",") ) {
			// Strip off quality and variable settings, and add to list
			headers << new String( value.split(";")[0] ).trim()
		}
	}
	return headers
}