/* 
-----------------------------------------------------------------------------
File: sendResponse.groovy
Author: Karl Bishop (kfbishop@us.ibm.com)
-----------------------------------------------------------------------------
(C) Copyright IBM Corp. 2008 All rights reserved.

You may only copy, modify, and distribute these samples internally.
These samples have not been tested under all conditions and are provided
to you by IBM without obligation of support of any kind.

IBM PROVIDES THESE SAMPLES "AS IS" SUBJECT TO ANY STATUTORY WARRANTIES THAT
CANNOT BE EXCLUDED. IBM MAKES NO WARRANTIES OR CONDITIONS, EITHER EXPRESS
OR IMPLIED, INCLUDING BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OR
CONDITIONS OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE, AND
NON-INFRINGEMENT REGARDING THESE SAMPLES OR TECHNICAL SUPPORT, IF ANY.
-----------------------------------------------------------------------------
*/
package rest

/**
 * Render our response as JSON.  
 * @input String (Json formatted), or actual Json/Groovy object
 */
def json(result) {
    logger.FINEST {"sending json data: ${result}"}; 
    request.headers.out."Content-Type" = "application/json"
    request.view="JSON"
    if (result instanceof java.lang.String ) {
        request.json.output = Json.decode(result)
    } else {
        request.json.output = result
    }
    render()
}

/**
 * Render our response as XML.  
 * @input String (Json formatted), or actual Json/Groovy object
 */
def xml(result, root) {
    logger.FINEST {"sending XML data: ${result}"}; 
    request.headers.out."Content-Type" = "text/xml"
    request.view="XML"
    if (result instanceof java.lang.String ) {
        request.xml.output = Json.decode(result)
    } else {
        request.xml.output = result
    }
    if ( root ) {
      request.xml.rootElement=root
    }
    render()
}
