package phpext;

import com.ibm.phpj.xapi.ExtensionBaseImpl;
import com.ibm.phpj.xapi.RuntimeContext;
import com.ibm.phpj.xapi.annotations.XAPIExtension;
import com.ibm.phpj.xapi.annotations.XAPIFunction;

//-- Produce standard Log4J logging calls.
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

@XAPIExtension("Logger")
public class Logger extends ExtensionBaseImpl {

    private Log log;
    private String prefix;

    @XAPIFunction("init_logger")
    public void init(RuntimeContext ctx) {
        String arg1 = ctx.getStringArgument(0).getString();
        log = LogFactory.getLog( arg1 );
        prefix = arg1 + ": ";
    }

    /* FATAL */    
    @XAPIFunction("fatal")
    public void fatal(RuntimeContext ctx) {
        log.fatal( prefix + ctx.getStringArgument(0).getString() );
    }
    @XAPIFunction("isFatalEnabled")
    public void isFatalEnabled(RuntimeContext ctx) {
        ctx.setReturnValue( log.isFatalEnabled() );
    }

    /* ERROR */    
    @XAPIFunction("error")
    public void error(RuntimeContext ctx) {
        log.error( prefix + ctx.getStringArgument(0).getString() );
    }
    @XAPIFunction("isErrorEnabled")
    public void isErrorEnabled(RuntimeContext ctx) {
        ctx.setReturnValue( log.isErrorEnabled() );
    }

    /* WARN */    
    @XAPIFunction("warn")
    public void warn(RuntimeContext ctx) {
        log.warn( prefix + ctx.getStringArgument(0).getString() );
    }
    @XAPIFunction("isWarnEnabled")
    public void isWarnEnabled(RuntimeContext ctx) {
        ctx.setReturnValue( log.isWarnEnabled() );
    }

    /* INFO */    
    @XAPIFunction("info")
    public void info(RuntimeContext ctx) {
        log.info( prefix + ctx.getStringArgument(0).getString() );
    }
    @XAPIFunction("isInfoEnabled")
    public void isInfoEnabled(RuntimeContext ctx) {
        ctx.setReturnValue( log.isInfoEnabled() );
    }

    /* DEBUG */    
    @XAPIFunction("debug")
    public void debug(RuntimeContext ctx) {
        log.debug( prefix + ctx.getStringArgument(0).getString() );
    }
    @XAPIFunction("isDebugEnabled")
    public void isDebugEnabled(RuntimeContext ctx) {
        ctx.setReturnValue( log.isDebugEnabled() );
    }

    /* TRACE */    
    @XAPIFunction("trace")
    public void trace(RuntimeContext ctx) {
        log.trace( prefix + ctx.getStringArgument(0).getString() );
    }
    @XAPIFunction("istraceEnabled")
    public void isTraceEnabled(RuntimeContext ctx) {
        ctx.setReturnValue( log.isTraceEnabled() );
    }
      
} 